import { setupDevtoolsPlugin } from '@vue/devtools-api';
import { App } from 'vue';

declare global {
  const __VUE_PROD_DEVTOOLS__: boolean;
}

export function setupDevtools(app: App) {
  setupDevtoolsPlugin(
    {
      id: '@yzcode/vue-devtool-vuex-z',
      label: 'vue-devtool-vuex',
      packageName: '@yzcode/vue-devtool-vuex-z',
      homepage: '',
      app,
    },
    (api) => {
      // api.on.visitComponentTree((payload, context) => {
      //   const node = payload.treeNode
      //   if (payload.componentInstance.type.showTag) {
      //     node.tags.push({
      //       label: 'showTag',
      //       textColor: 0x000000,
      //       backgroundColor: 0xff984f
      //     })
      //   }
      //  })

      const data = {
        message: '一欧洗洗脑',
        counter: 1,
      };

      api.on.inspectComponent((payload, context) => {
        payload.instanceData.state.push({
          type: 'My Awesome Plugin state',
          key: '$hello',
          value: data.message,
        });

        payload.instanceData.state.push({
          type: 'My Awesome Plugin state',
          key: 'time counter',
          value: data.counter,
        });
      });
    }
  );
}

export default {
  install(app: App, options = {}) {
    // Our Vue plugin logic
    if (process.env.NODE_ENV === 'development' || __VUE_PROD_DEVTOOLS__) {
      setupDevtools(app);
    }
  },
};
